#include <stdio.h>
#include <signal.h>
#include <setjmp.h>

sigjmp_buf genv;

void mysignal(int sig)
{
  printf("received signal %d\n",sig);
  siglongjmp(genv,1);
}


int main(int argc,char *argv[])
{
  int childpid;

  signal(SIGUSR1,mysignal);
  signal(SIGUSR2,mysignal);
  if((childpid=fork())==-1)
  {
      printf("fork failed\n");
      exit(-1);
  }
  else if(childpid==0)
  {
      printf("execlping child pid=%d",getpid());
      if(execlp("./child","./child",(char *)0)==-1)
      {
	 printf("execlp failed");
	 exit(-1);
      }
  }
  sigsetjmp(genv,1);
  for(;;)
  {
    printf("looping in parent\n");
    sleep(1);
  }
}
